#ifndef _AX_CONSOLE
#define _AX_CONSOLE

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>
//#include <cstdlib> 
//#include <termio.h>
//#include <unistd.h>
#include <dynamixelDefines.h>
#include "DxComm.h"
#include "DevCommUsb.h"


/*!\file 
This is a small console application for direct access to the bus components for testing and configuration. Currently supported elements are AX-12 servo, AX-S1 sensor module, 6 axis IMU. \todo RE-IMPLEMENT THIS CONSOLE APPLICATION WITH DETIDX \brief axConsole is a console application for Dynamixel manipulation.*/

/* Global variables */
int chosenID;
int chosenDevice;
int chosenSeries;
int CommStatus;
int deviceIndex=0;

/* Functions */
int mainMenu();
void searchAndList();
void setChosenID();
void setID();
void setBaud();
void setInterfaceBaud();

// XX-XX servo related functions
void printMotorData();
void motorToPos();
void motorAngleLimits();
void motorTorqueLimit();
void motorDefaultValues();

// 6-axis IMU related functions
void printImuData();

// Motors and IMU related functions
void toggleLed();

// AX-S1 related functions
void printAXs1Data();

// Auxiliary functions
void backToMainMenu();
void PrintCommStatus(int CommStatus);
void PrintErrorCode();


#endif

