#include <gtk/gtk.h>
#include "DxComm.h"
#include "DevCommUsb.h"
#include "dynamixelDefines.h"

GtkBuilder *builderG;

//necessário para compilar C com compilador C++
extern "C"{

//---LER valores 1
/**
 * @brief  This function handles the signal generated by the click of the button1
 * (Read Values), and it beggins a communication with the RX motors, after that it
 * sends reading instructions to the dynamixels in order to get the values of velocity
 * , position, temperature and voltage, so finally this information can be displayed
 * in the user interface.
 */
void on_button1_clicked(GtkButton *, gpointer )
{
	DxComm communicator = DxComm(new DevCommUsb());
	communicator.dxl_ping(RX_SERIES,1);
	communicator.dxl_ping(RX_SERIES,2);

	char leitura[30];

	//Motor 1
	//velocidade P_PRESENT_SPEED_L
	int velocidade;
	velocidade=communicator.dxl_read_word(RX_SERIES,1,P_PRESENT_SPEED_L);
	sprintf(leitura,"%d",velocidade);
	gtk_entry_set_text(GTK_ENTRY(gtk_builder_get_object(builderG,"entry1")),leitura);

	//posicao P_PRESENT_POSITION_L
	int posicao;
	posicao=communicator.dxl_read_word(RX_SERIES,1,P_PRESENT_POSITION_L);
	sprintf(leitura,"%d",posicao);
	gtk_entry_set_text(GTK_ENTRY(gtk_builder_get_object(builderG,"entry2")),leitura);

	//temperatura P_PRESENT_TEMPERATURE
	int temperatura;
	temperatura=communicator.dxl_read_word(RX_SERIES,1,P_PRESENT_TEMPERATURE);
	sprintf(leitura,"%d",temperatura);
	gtk_entry_set_text(GTK_ENTRY(gtk_builder_get_object(builderG,"entry3")),leitura);

	//tensão P_PRESENT_VOLTAGE
	int tensao;
	tensao=communicator.dxl_read_word(RX_SERIES,1,P_PRESENT_VOLTAGE);
	sprintf(leitura,"%d",tensao);
	gtk_entry_set_text(GTK_ENTRY(gtk_builder_get_object(builderG,"entry4")),leitura);

	//Motor 2
	//velocidade P_PRESENT_SPEED_L
	velocidade=communicator.dxl_read_word(RX_SERIES,2,P_PRESENT_SPEED_L);
	sprintf(leitura,"%d",velocidade);
	gtk_entry_set_text(GTK_ENTRY(gtk_builder_get_object(builderG,"entry11")),leitura);

	//posicao P_PRESENT_POSITION_L
	posicao=communicator.dxl_read_word(RX_SERIES,2,P_PRESENT_POSITION_L);
	sprintf(leitura,"%d",posicao);
	gtk_entry_set_text(GTK_ENTRY(gtk_builder_get_object(builderG,"entry12")),leitura);

	//temperatura P_PRESENT_TEMPERATURE
	temperatura=communicator.dxl_read_word(RX_SERIES,2,P_PRESENT_TEMPERATURE);
	sprintf(leitura,"%d",temperatura);
	gtk_entry_set_text(GTK_ENTRY(gtk_builder_get_object(builderG,"entry13")),leitura);

	//tensão P_PRESENT_VOLTAGE
	tensao=communicator.dxl_read_word(RX_SERIES,2,P_PRESENT_VOLTAGE);
	sprintf(leitura,"%d",tensao);
	gtk_entry_set_text(GTK_ENTRY(gtk_builder_get_object(builderG,"entry14")),leitura);

}

//---LER valores 2
/**
 * @brief  This function handles the signal generated by the click of the button1
 * (Read Values), and it beggins a communication with the RX motors, after that it
 * sends reading instructions to the dynamixels in order to get the values of the
 * programed velocity, CW Angle limit, CCW Angle limit and to know if Torque is 
 * enabled, so finally this information can be displayed in the user interface.
 */
void on_button8_clicked(GtkButton *, gpointer )
{
	DxComm communicator = DxComm(new DevCommUsb());
	communicator.dxl_ping(RX_SERIES,1);
	communicator.dxl_ping(RX_SERIES,2);

	char leitura[30];

	//Motor 1
	//velocidade programada P_GOAL_SPEED_L
	int velocidade;
	velocidade=communicator.dxl_read_word(RX_SERIES,1,P_GOAL_SPEED_L);
	sprintf(leitura,"%d",velocidade);
	gtk_entry_set_text(GTK_ENTRY(gtk_builder_get_object(builderG,"entry9")),leitura);

	//limite angulo cw P_CW_ANGLE_LIMIT_L
	int cwangle;
	cwangle=communicator.dxl_read_word(RX_SERIES,1,P_CW_ANGLE_LIMIT_L);
	sprintf(leitura,"%d",cwangle);
	gtk_entry_set_text(GTK_ENTRY(gtk_builder_get_object(builderG,"entry10")),leitura);

	//limite angulo cw P_CCW_ANGLE_LIMIT_L
	int ccwangle;
	ccwangle=communicator.dxl_read_word(RX_SERIES,1,P_CCW_ANGLE_LIMIT_L);
	sprintf(leitura,"%d",ccwangle);
	gtk_entry_set_text(GTK_ENTRY(gtk_builder_get_object(builderG,"entry17")),leitura);

	//torque P_TORQUE_ENABLE
	int torque;
	torque=communicator.dxl_read_word(RX_SERIES,1,P_TORQUE_ENABLE);
	sprintf(leitura,"%d",torque);
	gtk_entry_set_text(GTK_ENTRY(gtk_builder_get_object(builderG,"entry21")),leitura);


	//Motor 2
	//velocidade programada P_GOAL_SPEED_L
	velocidade=communicator.dxl_read_word(RX_SERIES,2,P_GOAL_SPEED_L);
	sprintf(leitura,"%d",velocidade);
	gtk_entry_set_text(GTK_ENTRY(gtk_builder_get_object(builderG,"entry18")),leitura);

	//limite angulo cw P_CW_ANGLE_LIMIT_L
	cwangle=communicator.dxl_read_word(RX_SERIES,2,P_CW_ANGLE_LIMIT_L);
	sprintf(leitura,"%d",cwangle);
	gtk_entry_set_text(GTK_ENTRY(gtk_builder_get_object(builderG,"entry19")),leitura);

	//limite angulo cw P_CCW_ANGLE_LIMIT_L
	ccwangle=communicator.dxl_read_word(RX_SERIES,2,P_CCW_ANGLE_LIMIT_L);
	sprintf(leitura,"%d",ccwangle);
	gtk_entry_set_text(GTK_ENTRY(gtk_builder_get_object(builderG,"entry20")),leitura);

	//torque P_TORQUE_ENABLE
	torque=communicator.dxl_read_word(RX_SERIES,2,P_TORQUE_ENABLE);
	sprintf(leitura,"%d",torque);
	gtk_entry_set_text(GTK_ENTRY(gtk_builder_get_object(builderG,"entry22")),leitura);
}

//-------------------------------------------
//-----------mover em continuo
//motor1
/**
 * @brief  This function handles the signal generated by the pressing of the button2
 * (Move Motor 1), and it beggins a communication with the RX motors, after that it
 * gets the value of the desired velocity from entry5, then this velocity is programed
 * in the motors and the dynamixels CCW and CW angle limit are set to 0, in order to
 * begin an endless turn.
 * @param  user_data as the id of the entry wich holds the value of the desired velocity
 */
gboolean on_button2_button_press_event (GtkWidget * , GdkEvent  *, gpointer user_data)
{
	DxComm communicator = DxComm(new DevCommUsb());

	communicator.dxl_ping(RX_SERIES,1);
	
	GtkEntry *ts= (GtkEntry *)user_data;
	const char * tss=gtk_entry_get_text(ts);
	long val;
	val=atol(tss);

	communicator.dxl_write_word(RX_SERIES,1,P_GOAL_SPEED_L,val);
	
	communicator.dxl_write_word(RX_SERIES,1,P_CCW_ANGLE_LIMIT_L,0);
	communicator.dxl_write_word(RX_SERIES,1,P_CW_ANGLE_LIMIT_L,0);

	return TRUE;
}
/**
 * @brief  This function handles the signal generated by the releasing of the button2
 * (Move Motor 1), and it beggins a communication with the RX motors, after that it
 * gets the current position of the motor and it commands the motors to this position
 * after that the CW and CCW angle limtis are set to standard values. 
 * This function isn't working as it should be, it needs more testing!!
 */
gboolean on_button2_button_release_event (GtkWidget *, GdkEvent *, gpointer)
{
	//pode ser desnecessario iniciar a comunicacao pois esta funcao é chamada
	//imediatamente a seguir à on_button2_pressed_release_event
	//testar isto!!!!
	DxComm communicator = DxComm(new DevCommUsb());
	communicator.dxl_ping(RX_SERIES,1);

	int leitura;
	leitura=communicator.dxl_read_word(RX_SERIES,1,P_PRESENT_POSITION_L);
	//printf("%d\n",leitura); //para ler o valor da posicao atual para o motor ficar lá
	communicator.dxl_write_word(RX_SERIES,1,P_GOAL_POSITION_L,leitura);
	//nao esta a ficar nesta posicao, apesar de o valor da leitura ser a posicao atual,
	//o motor nao cumpre o comando goal position
	// ou entao o goal positon tem de ser enviado depois dos limites dos angulos
	//testar isto!!!!
	communicator.dxl_write_word(RX_SERIES,1,P_CCW_ANGLE_LIMIT_L,1023);
	communicator.dxl_write_word(RX_SERIES,1,P_CW_ANGLE_LIMIT_L,0);
	
	return TRUE;
}
//motor 2
/**
 * @brief  This function handles the signal generated by the pressing of the button3
 * (Move Motor 2), and it beggins a communication with the RX motors, after that it
 * gets the value of the desired velocity from entry6, then this velocity is programed
 * in the motors and the dynamixels CCW and CW angle limit are set to 0, in order to
 * begin an endless turn.
 * @param  user_data as the id of the entry wich holds the value of the desired velocity
 */
gboolean on_button3_button_press_event (GtkWidget * , GdkEvent  *, gpointer user_data)
{
	DxComm communicator = DxComm(new DevCommUsb());

	communicator.dxl_ping(RX_SERIES,2);
	
	GtkEntry *ts= (GtkEntry *)user_data;
	const char * tss=gtk_entry_get_text(ts);
	long val;
	val=atol(tss);
	//printf("%ld\n",val);
	communicator.dxl_write_word(RX_SERIES,2,P_GOAL_SPEED_L,val);
	
	communicator.dxl_write_word(RX_SERIES,2,P_CCW_ANGLE_LIMIT_L,0);
	communicator.dxl_write_word(RX_SERIES,2,P_CW_ANGLE_LIMIT_L,0);

	return TRUE;
}
/**
 * @brief  This function handles the signal generated by the releasing of the button3
 * (Move Motor 2), and it beggins a communication with the RX motors, after that it
 * gets the current position of the motor and it commands the motors to this position
 * after that the CW and CCW angle limtis are set to standard values. 
 * This function isn't working as it should be, it needs more testing!!
 */
gboolean on_button3_button_release_event (GtkWidget *, GdkEvent *, gpointer)
{
	DxComm communicator = DxComm(new DevCommUsb());
	communicator.dxl_ping(RX_SERIES,2);

	int leitura;
	leitura=communicator.dxl_read_word(RX_SERIES,2,P_PRESENT_POSITION_L);
	//printf("%d\n",leitura); //para ler o valor da posicao atual para o motor ficar lá
	communicator.dxl_write_word(RX_SERIES,2,P_GOAL_POSITION_L,leitura);
	//nao esta a ficar nesta posicao, apesar de o valor da leitura ser a posicao atual,
	//o motor nao cumpre o comando goal position
	communicator.dxl_write_word(RX_SERIES,2,P_CCW_ANGLE_LIMIT_L,1023);
	communicator.dxl_write_word(RX_SERIES,2,P_CW_ANGLE_LIMIT_L,0);
	return TRUE;
}

//-------------------------------------------------------------
//------GO TO POSITION

/**
 * @brief  This function handles the signal generated by the click of the button4
 * (Move Motor 1), and it beggins a communication with Motor 1, after that it
 * gets the value of the desired position to achieve and it commands the dynamixel to
 * this position.
 * @param  user_data contains the id of the entry wich holds the value of the position
 */

void on_button4_clicked(GtkButton *, gpointer user_data)
{
	DxComm communicator = DxComm(new DevCommUsb());
	communicator.dxl_ping(RX_SERIES,1);

	GtkEntry *ts= (GtkEntry *)user_data;
	const char * tss=gtk_entry_get_text(ts);
	long val;
	val=atol(tss);
	//printf("%ld\n",val);
	communicator.dxl_write_word(RX_SERIES,1,P_GOAL_POSITION_L,val);
}
/**
 * @brief  This function handles the signal generated by the click of the button5
 * (Move Motor 2), and it beggins a communication with Motor 2, after that it
 * gets the value of the desired position to achieve and it commands the dynamixel to
 * this position.
 * @param  user_data contains the id of the entry wich holds the value of the position
 */
void on_button5_clicked(GtkButton *, gpointer user_data)
{
	DxComm communicator = DxComm(new DevCommUsb());
	communicator.dxl_ping(RX_SERIES,2);

	GtkEntry *ts= (GtkEntry *)user_data;
	const char * tss=gtk_entry_get_text(ts);
	long val;
	val=atol(tss);
	//printf("%ld\n",val);
	communicator.dxl_write_word(RX_SERIES,2,P_GOAL_POSITION_L,val);
}
//----------------------------------------------------------------
//------Configurar velocidade
//--motor 1
/**
 * @brief  This function handles the signal generated by the click of the button6
 * (Validate Motor 1), and it beggins a communication with Motor 1, after that it
 * gets the value of the desired velocity and it programs the dynamixel.
 * @param  user_data contains the id of the entry wich holds the value of the velocity
 */
void on_button6_clicked(GtkButton *, gpointer user_data)
{
	DxComm communicator = DxComm(new DevCommUsb());
	communicator.dxl_ping(RX_SERIES,1);

	GtkEntry *ts= (GtkEntry *)user_data;
	const char * tss=gtk_entry_get_text(ts);
	long val;
	val=atol(tss);
	communicator.dxl_write_word(RX_SERIES,1,P_GOAL_SPEED_L,val);
}

//--motor 2
/**
 * @brief  This function handles the signal generated by the click of the button7
 * (Validate Motor 2), and it beggins a communication with Motor 2, after that it
 * gets the value of the desired velocity and it programs the dynamixel.
 * @param  user_data contains the id of the entry wich holds the value of the velocity
 */
void on_button7_clicked(GtkButton *, gpointer user_data)
{
	DxComm communicator = DxComm(new DevCommUsb());
	communicator.dxl_ping(RX_SERIES,2);

	GtkEntry *ts= (GtkEntry *)user_data;
	const char * tss=gtk_entry_get_text(ts);
	long val;
	val=atol(tss);
	communicator.dxl_write_word(RX_SERIES,2,P_GOAL_SPEED_L,val);
}
//--------------------------------------------------
//-------Acender LED dos motores
/**
 * @brief  This function handles the signal generated by the toggle of the toggle_button1
 * (LED Motor1), and it beggins a communication with Motor 1, after that it checks the state
 * fo the button and powers on or off the led of the motor.
 * @param  toggle_button contains the state of the toggle button, 1 if it's active or 0 if it's
 * not active.
 */
void on_togglebutton1_toggled(GtkToggleButton *toggle_button)
{
	DxComm communicator = DxComm(new DevCommUsb());
	communicator.dxl_ping(RX_SERIES,1);

	if (gtk_toggle_button_get_active (toggle_button))
	{
		communicator.dxl_write_word(RX_SERIES,1,P_LED,1);
	}
	else
	{
		communicator.dxl_write_word(RX_SERIES,1,P_LED,0);
	}
}
/**
 * @brief  This function handles the signal generated by the toggle of the toggle_button2
 * (LED Motor2), and it beggins a communication with Motor 2, after that it checks the state
 * fo the button and powers on or off the led of the motor.
 * @param  toggle_button contains the state of the toggle button, 1 if it's active or 0 if it's
 * not active.
 */
void on_togglebutton2_toggled(GtkToggleButton *toggle_button)
{
	DxComm communicator = DxComm(new DevCommUsb());
	communicator.dxl_ping(RX_SERIES,2);

	if (gtk_toggle_button_get_active (toggle_button))
	{
		communicator.dxl_write_word(RX_SERIES,2,P_LED,1);
	}
	else
	{
		communicator.dxl_write_word(RX_SERIES,2,P_LED,0);
	}
}

/**
 * @brief  This function handles the signal generated by the click of the button9
 * (Execute), and it beggins a communication with both motors, after that it
 * gets the value of the desired postion and it commands the dynamixels at the same time.
 */
void on_button9_clicked(GtkButton *, gpointer)
{
	DxComm communicator = DxComm(new DevCommUsb());
	communicator.dxl_ping(RX_SERIES,1);
	communicator.dxl_ping(RX_SERIES,2);
	
	const char * valor1;
	valor1 = gtk_entry_get_text(GTK_ENTRY(gtk_builder_get_object(builderG,"entry23")));
	long val1;
	val1=atol(valor1);

	const char * valor2;
	valor2 = gtk_entry_get_text(GTK_ENTRY(gtk_builder_get_object(builderG,"entry24")));
	long val2;
	val2=atol(valor2);

	int idArray[2];
	idArray[0]=1;
	idArray[1]=2;
	int valuesArray[2];
	valuesArray[0] = val1;
	valuesArray[1] = val2;

	communicator.dxl_syncWrite_word(RX_SERIES, 2, P_GOAL_POSITION_L, idArray, valuesArray);
}

/**
 * @brief  Se a janela da interface for fechada o programa também é parado.
 */

gboolean delete_event(GtkWidget * , GdkEvent * , gpointer)
{
	gtk_main_quit();
	return TRUE;
}

}//fim do exter C

int main(int argc, char* argv[])
{

	gtk_init(&argc, &argv);

	// load the interface after a configuration file
	builderG = gtk_builder_new();
	gtk_builder_add_from_file(builderG, "layout_pari.glade", NULL);

	// connect the signals in the interface 
	gtk_builder_connect_signals(builderG, NULL);

	// get main window Widget ID and connect special signals 
	GtkWidget *t = GTK_WIDGET(gtk_builder_get_object(builderG, "window1"));
	if(t)
	{
		g_signal_connect(G_OBJECT(t), "delete_event", G_CALLBACK(delete_event), NULL);
	}


	// start the event loop
	gtk_main();

}
